#include <strings.h>
#include <string.h>
#include <stdio.h>
#include <stdlib.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>

#include "common.h"
#include "http.h"

#define BUFFSIZE 1024

int is_http(char *url)
{
	if (strlen(url) < 8)
		return 0;

	if (!strncasecmp("http://",url,7))
		return 1;

	return 0;
}

int open_http(char *url)
{
	int fd;
	struct sockaddr_in server;
	static struct dvb_host *dvbhost = NULL;
	char buffer[BUFFSIZE];
	int i;

	if(!is_http(url))
		return -1;

	if (!dvbhost) {
		dvbhost = parse(&(url[7]), "80");
		dvbhost->socktype = SOCK_STREAM;
	}

	if (resolve(dvbhost, &server) < 0) {
		return -1;
	}

	if ((fd = socket(AF_INET, SOCK_STREAM, IPPROTO_TCP)) < 0) {
		perror("socket");
		return -1;
	}

	if (connect(fd, (struct sockaddr*) &server, sizeof(server)) < 0) {
		perror("connect");
		return -1;
	}

	snprintf(buffer, BUFFSIZE-1, "GET /%s HTTP/1.0\n\n",dvbhost->location);
	buffer[BUFFSIZE-1] = 0;
	send(fd, buffer, strlen(buffer), 0);
	i = 0;
	while(i < 2) {
		if (recv(fd, buffer, 1, 0) < 1) {
			perror("recv");
			exit(EXIT_FAILURE);
		}
		printf("%c",buffer[0]);
		if (buffer[0] == 0x0a)
			i++;
		else
			if (buffer[0] != 0x0d)
				i = 0;
	}

	return fd;
}
